
     .data
val: .word  0xa7b5ff90  @ dato de ejemplo
res: .space 10          @ resultado

   .text
main:
   ldr   r4, =val     @ dirección del dato
   ldr   r5, =res     @ dirección del resultado
@
@ ponemos el marcador hex '0x'
@
   mov   r3, #'0'
   strb  r3, [r5]
   mov   r3, #'x'
   strb  r3, [r5, #1]
   add   r5, r5, #2
@
@ convertimos y almacenamos
@
   mov   r6, #7       @ contador de dígitos
   ldr   r4, [r4]     @ cargamos el número en r4

otro:    
   mov   r0, r4       
   bl    hextoa       @ convertimos el nibble menos significativo
   strb  r0, [r5, r6] @ lo almacenamos en su sitio
   cmp   r6, #0       @ ¿hemos terminado?
   beq   final      
 
   lsr   r4, r4, #4   @ lo desplazamos un nibble
   sub   r6, r6, #1   @ restamos 1 del contador / puntero
   b     otro         @ y otra vez

final:
   wfi

/* subrutina para pasar un dígito en binario a ASCII en hexadecimal
   entrada: r0 dígito en binario (4 bits menos significativos). 
      Se ignora el resto.
   salida:  r0: carácter ASCII del número (8 bits menos  
      significativos). Resto a cero.
*/

hextoa:   
   mov   r1, #0x0f     @ enmascaramos todo menos el nibble menos 
   and   r0, r0, r1    @ significativo
   cmp   r0, #0x09     @ vemos si '0' - '9' o 'A' - 'Z'
   bhi   msr1

   add   r0, r0, #'0'  @ menor que 9 
   b     dsr1

msr1:    
   add   r0, r0, #0x37   @ mayor que 9 : 0x0A + 0x37 = 0x41 = 'A'
dsr1:    
   mov   pc,lr
   .end