
      .data
strm: .byte   0x00, 0x01, 0x02, 0x70, 0x71, 0x72, 0x0f, 0x04

   .text
main:
   ldr   r4, =strm  @ r4: para navegar la lista de números
bucle:   
   ldrb  r0, [r4]
   cmp   r0, #0x04
   beq   fin        @ si es EOT, terminamos (sin convertirlo, es par)

   bl    setppar    @ llamamos al subprograma para 
   strb  r0, [r4]   @ convertir este carácter.
   add   r4, r4, #1
   b     bucle

fin:   wfi

/*
 setppar: subprograma que cuenta el numero de bits a 1 
 en el byte menos significativo de r0, 
 y devuelve en r0 el byte con la paridad correcta.

Entrada: r0: byte a comprobar.
Salida:  r0: con paridad par.

*/

setppar:   
   mov   r3, r0      @ guardamos una copia de r0
   lsl   r3, r3, #24 @ desplazamos el byte hasta que quede al borde
   mov   r2, #0      @ contador de bits a 1
   mov   r1, #7      @ contador de desplazamientos

pbuc:   
   lsl   r3, r3, #1  @ el bit menos significativo va al signo
   bpl   nosuma      @ si no es uno, pasamos al siguiente

   add   r2, r2, #1  @ incrementamos el contador de unos
nosuma:   
   sub   r1, r1, #1
   bne   pbuc        @ al siguiente si no hemos acabado

   lsr   r2, #1      @ vemos si la cuenta es par o impar
   bcc   espar       @ si es par, acabamos

   mov   r1, #0x80   @ máscara para activar el bit de paridad
   orr   r0, r0, r1  @ lo activamos

espar:   
   mov   pc,lr
   .end
