      .data
zona: .hword 2, 1, 7, 8, 5, 6, 4, 9, 3      
      .equ   tam, 9

      .text

/* Tenemos que rotar la zona dos veces */

main: ldr  r0,=zona    @ r0: dirección de la zona
      mov  r1,#tam     @ r1: tamaño
      bl   rota        @ rotamos

      ldr  r0,=zona 
      mov  r1,#tam
      bl   rota        @ rotamos otra vez
nomov:      
      wfi  

/*
 rota: Subprograma para rotar las medias palabras
 almacenadas en una zona de memoria.
 Argumentos:
      r0: dirección de comienzo de la zona.
      r1: tamaño (en medias palabras) de la zona.
*/
rota:
/*    
Primero comprobamos si hay medias palabras que rotar
*/

      cmp  r1,#1       @ si la zona no tiene al menos dos
      ble  done        @ medias palabras, hemos terminado.

      sub  r1,r1,#1    @ calculamos el fin de la zona
      lsl  r1,#1         
      add  r1,r1,r0    @ r1: apunta ahora al último elemento

      ldrh r2,[r1]     @ movemos el primero al
      ldrh r3,[r0]     @ último a través de r3
      strh r3,[r1]

otro: ldrh r3,[r0,#2]  @ movemos hacia abajo
      strh r3,[r0]     @ desde el segundo
      add  r0,#2
      cmp  r0, r1            
      bne  otro

      sub  r0,#2
      strh r2,[r0]     @ movemos el último al penúltimo

done: mov  pc,lr       @ y terminamos
      .end
